% Demonstration of the A* algorithm

n = 10;   % field size n x n tiles

%board = frontierBoard(n);
%board = clearBoard(n);
%board = pacmanBoard(n);
%board = zigzagBoard(n);
%board = loopBoard(n);
%board = laneBoard(n);
board = threeLaneBoard(n);

[path, nodes, cost, policy] = astar (board,'manhattan');

showPolicyMap(board,policy,'A* policy');


[policy] = mdpPolicy(board);

showPolicy(board,policy, 'MDP policy');

[path, orientation] = mdpPath(board,policy,board.start.x, board.start.y, board.start.orientation);

showPath(path,orientation);



[policy] = stochasticPolicy(board,0.0001);

showPolicy(board,policy, 'Stochastic policy (0.0001)');

[path, orientation] = mdpPath(board,policy,board.start.x, board.start.y, board.start.orientation);

showPath(path,orientation);




[policy] = stochasticPolicy(board,0.001);

showPolicy(board,policy, 'Stochastic policy (0.001)');

[path, orientation] = mdpPath(board,policy,board.start.x, board.start.y, board.start.orientation);

showPath(path,orientation);



[policy] = stochasticPolicy(board,0.01);

showPolicy(board,policy, 'Stochastic policy (0.01)');

for i=1:100 % Try different scenarios to see potential failures
    [path, orientation] = stochasticPath(board,policy,board.start.x, board.start.y, board.start.orientation, 0.01);
    showPath(path,orientation,'r');
end;

[path, orientation] = mdpPath(board,policy,board.start.x, board.start.y, board.start.orientation);
showPath(path,orientation,'g');
