function board = loopBoard(n)
% A loop

    board.n = n;
    
    % create start position and goal position
    board.start.x = floor(n/2)+1;
    board.start.y = 2;
    board.start.orientation = 'N';
    board.goal.x  = 2;
    board.goal.y  = floor(n/2)+1;
    
    % create the board and place walls with board.wallinite cost
    board.cost = ones(n,n);
    board.wall = 10000;
    
    board.cost(1:floor(n/2)-1,floor(n/2)-1) = board.wall;
    board.cost(floor(n/2)-1,1:floor(n/2)-1) = board.wall;

    board.cost(1:floor(n/2)-1,floor(n/2)+2) = board.wall;
    board.cost(floor(n/2)-1,floor(n/2)+2:n) = board.wall;

    board.cost(floor(n/2)+2:n,floor(n/2)-1) = board.wall;
    board.cost(floor(n/2)+2,1:floor(n/2)-1) = board.wall;

    board.cost(floor(n/2)+2:n-2,floor(n/2)+2) = board.wall;
    board.cost(floor(n/2)+2,floor(n/2)+2:n-2) = board.wall;

    board.cost(floor(n/2)+2:n-2,n-2) = board.wall;
    board.cost(n-2,floor(n/2)+2:n-2) = board.wall;

    % force movement cost at start and goal positions to not be walls
    board.cost(board.start.x, board.start.y) = 0; 

    % put not a numbers (NaN) in cost chart so A* knows where to look 
    board.costchart = NaN*ones(n,n);
    % set the cost at the starting position to be 0
    board.costchart(board.start.x, board.start.y) = 0;
