function [policy map] = mdpPolicy(board)
% MDP

n = board.n;

for x=1:n
    for y=1:n
        for o=1:length(orientations())
            value(x,y,o) = 999999;
            policy(x,y,o) = '.';
        end
        map(x,y) = '.';
    end
end


[orientation, mark] = orientations(board);
action = actions(board);

change = true;

while (change)

    change = false;

    for x=1:n
        for y=1:n

            if (board.goal.x==x) && (board.goal.y == y)
                if value(x,y)>0
                    change = true; 
                    for k=1:length(orientation)
                        value(x,y,k) = 0;
                        policy(x,y,k) = 'X';
                    end
                    map(x,y) = 'o';
                end

            elseif (board.cost(x,y) ~= board.wall)

                for k=1:length(orientation)

                    state = newState(x,y,orientation(k));

                    for a=1:length(action)
                    
                        next = nextState(board,state,action(a));
                        nextOrientation = find(orientation==next.orientation);

                        if ~sameState(state,next)
                           newValue = value(next.x,next.y,nextOrientation) + cost(board,state,action(a),next);
                           if newValue < value(x,y,k)   
                              change = true;
                              value(x,y,k) = newValue;
                              policy(x,y,k) = action(a);
                           end
                        end
                    end
                end

            end
        end
    end

end


% MAP

for x=1:n
    for y=1:n
        [minval, minpos] = min(value(x,y,:));
        if minval<999999
           map(x,y) = mark(minpos);
        end
    end
end


