function board = pacmanBoard(n)
% This function will create a field with movement costs and walls, a start
% and goal position at random, a matrix in which the algorithm will store 
% f values, and a cell matrix in which it will store pointers

    board.n = n;
    
    % create start position and goal position
    board.start.x = 2;
    board.start.y = 2;
    board.start.orientation = 'N';
    board.goal.x  = n-1;
    board.goal.y  = n-1;
    
    % create the board and place walls with a high collision cost
    board.cost = ones(n,n);
    board.wall = 10000;
    
    board.cost(4,4:8) = board.wall;
    board.cost(4:8,4) = board.wall;

    board.cost(4,n-7:n-3) = board.wall;
    board.cost(4:8,n-3) = board.wall;

    board.cost(n-3,4:8) = board.wall;
    board.cost(n-7:n-3,4) = board.wall;

    board.cost(n-3,n-7:n-3) = board.wall;
    board.cost(n-7:n-3,n-3) = board.wall;

    board.cost(8,8:n-7) = board.wall;
    board.cost(n-7,8:n-7) = board.wall;
    board.cost(8:n-7,8) = board.wall;

    % force movement cost at start and goal positions to not be walls
    board.cost(board.start.x, board.start.y) = 0; 


    % put not a numbers (NaN) in cost chart so A* knows where to look 
    board.costchart = NaN*ones(n,n);
    % set the cost at the starting position to be 0
    board.costchart(board.start.x, board.start.y) = 0;
