function showPath (p,o,color)

  if nargin<3
      color='r';
  end

[direction, mark] = orientations();

for i=1:size(p,1)
  x = p(i,2);
  y = p(i,1);
  orientation = find(direction==o(i));
  plot (x+0.5, y+0.5, [mark(orientation),color], 'MarkerSize',10,'LineWidth',4);
end


for i=1:size(p,1)-1

  x = p(i,2);
  y = p(i,1);

  switch (o(i))

    case 'N'
      plotLine([x x]+0.5,[y y+0.5]+0.5,color);

    case 'S'
      plotLine([x x]+0.5,[y y-0.5]+0.5,color);

    case 'E'
      plotLine([x x+0.5]+0.5,[y y]+0.5,color);

    case 'W'
      plotLine([x x-0.5]+0.5,[y y]+0.5,color);

  end


  x = p(i+1,2);
  y = p(i+1,1);

  switch (o(i+1))

    case 'N'
      plotLine([x x]+0.5,[y-0.5 y]+0.5,color);

    case 'S'
      plotLine([x x]+0.5,[y+0.5 y]+0.5,color);

    case 'E'
      plotLine([x-0.5 x]+0.5,[y y]+0.5,color);

    case 'W'
      plotLine([x+0.5 x]+0.5,[y y]+0.5,color);

   end

   % Arcs

   if o(i)~=o(i+1)

      xc = ( p(i,2) + p(i+1,2) ) / 2 + 0.5;
      yc = ( p(i,1) + p(i+1,1) ) / 2 + 0.5;

      if (p(i,2)==p(i+1,2))
         xc = p(i,2) + (o(i+1)=='E')
      end

      if (p(i,1)==p(i+1,1))
         yc == p(i,1) + (o(i+1)=='N')
      end

      switch [o(i) o(i+1)]

        case {'ES', 'NW'}
          startAngle = 0;
          endAngle = pi/2;

        case {'WS', 'NE'}
          startAngle = pi/2;
          endAngle = pi;

        case {'WN', 'SE'}
          startAngle = pi;
          endAngle = 3*pi/2;

        case {'EN', 'SW'}
          startAngle = 3*pi/2;
          endAngle = 2*pi;

        otherwise
          startAngle = 0;
          endAngle = 2*pi;
      end

      plotArc(xc,yc,0.5,startAngle,endAngle,color);

   end

end

end


function plotLine (x, y, color)  
  plot(x,y,'Color',color,'LineWidth',4);
end


function plotArc (x,y,r, startAngle, endAngle, color, nsegments)  

  if nargin<7
      nsegments=50;
  end

  if nargin<6
      color='r';
  end

  th = startAngle:(endAngle-startAngle)/nsegments:endAngle;
  xarc = r * cos(th) + x;
  yarc = r * sin(th) + y;
  plot(xarc, yarc,'Color',color,'LineWidth',4);

end

