function [p,o] = mdpPath(board, policy, initialX, initialY, initialOrientation, failureProbability)


[direction, mark] = orientations(board);

state = newState(initialX,initialY,initialOrientation);

p(1,2) = state.x;
p(1,1) = state.y;
o(1) = state.orientation; 
len = 1;

orientation = find(direction==state.orientation);

while ((state.x~=board.goal.x) || (state.y~=board.goal.y)) && (policy(state.x,state.y,orientation)~='.')

  % plot (state.x+0.5, state.y+0.5, [mark(orientation),'r'], 'MarkerSize',10,'LineWidth',4);

  action = policy(state.x,state.y,orientation);

 
  if rand()<failureProbability  

     if action=='G' % Unintended turn

        if rand()<0.5
           action='L';
        else
           action='R';
        end

     else % Turn failure
        action = 'G';
     end

  end

  next = nextState(board,state,action);

  p(len+1,2) = next.x;
  p(len+1,1) = next.y;
  o(len+1) = next.orientation; 
  len = len + 1;

  state = next;
  orientation = find(direction==state.orientation);
end


