function puntos = test ()

puntos = 0;

% 20% Estados del problema

puntos = puntos +  2.0*testInitialState();
puntos = puntos +  1.0*testSameState();
puntos = puntos +  2.0*testFinalState();
puntos = puntos + 15.0*testNextState();

% 15% Funciones heursticas

puntos = puntos + 1.0*testHeuristic('pacman15', 'ucs',        pacmanBoard(15), 0);
puntos = puntos + 1.0*testHeuristic('pacman15', 'euclidean',  pacmanBoard(15), sqrt(12*12));
puntos = puntos + 2.0*testHeuristic('pacman15', 'manhattan',  pacmanBoard(15), 24/2);
puntos = puntos + 1.0*testHeuristic('pacman15', 'chessboard', pacmanBoard(15), 12);

puntos = puntos + 1.0*testHeuristic('frontier15', 'ucs',        frontierBoard(15), 0);
puntos = puntos + 1.0*testHeuristic('frontier15', 'euclidean',  frontierBoard(15), 9/sqrt(2));
puntos = puntos + 2.0*testHeuristic('frontier15', 'manhattan',  frontierBoard(15), 9/2);
puntos = puntos + 1.0*testHeuristic('frontier15', 'chessboard', frontierBoard(15), 9);

puntos = puntos + 1.0*testHeuristic('cost15', 'ucs',        costBoard(15), 0);
puntos = puntos + 1.0*testHeuristic('cost15', 'euclidean',  costBoard(15), sqrt(288/2));
puntos = puntos + 2.0*testHeuristic('cost15', 'manhattan',  costBoard(15), 24/2);
puntos = puntos + 1.0*testHeuristic('cost15', 'chessboard', costBoard(15), 12);

% 32% Algoritmo A*

set(0,'DefaultFigureVisible','off'); 

disp('[A*] Algoritmo A*...');

puntos = puntos + 1.0*testAStar('clear10', 'ucs',        clearBoard(10), [13 286]);
puntos = puntos + 1.0*testAStar('clear10', 'euclidean',  clearBoard(10), [13 125]);
puntos = puntos + 1.0*testAStar('clear10', 'manhattan',  clearBoard(10), [13 146]);
puntos = puntos + 1.0*testAStar('clear10', 'chessboard', clearBoard(10), [13 106]);

puntos = puntos + 1.0*testAStar('frontier10', 'ucs',        frontierBoard(10), [6 30]);
puntos = puntos + 1.0*testAStar('frontier10', 'euclidean',  frontierBoard(10), [6 6]);
puntos = puntos + 1.0*testAStar('frontier10', 'manhattan',  frontierBoard(10), [6 8]);
puntos = puntos + 1.0*testAStar('frontier10', 'chessboard', frontierBoard(10), [6 6]);

puntos = puntos + 1.0*testAStar('cost10', 'ucs',        costBoard(10), [13 200]);
puntos = puntos + 1.0*testAStar('cost10', 'euclidean',  costBoard(10), [13 150]);
puntos = puntos + 1.0*testAStar('cost10', 'manhattan',  costBoard(10), [13 157]);
puntos = puntos + 1.0*testAStar('cost10', 'chessboard', costBoard(10), [13 140]);

puntos = puntos + 1.0*testAStar('pacman10', 'ucs',        pacmanBoard(10), [13 66]);
puntos = puntos + 1.0*testAStar('pacman10', 'euclidean',  pacmanBoard(10), [13 32]);
puntos = puntos + 1.0*testAStar('pacman10', 'manhattan',  pacmanBoard(10), [13 36]);
puntos = puntos + 1.0*testAStar('pacman10', 'chessboard', pacmanBoard(10), [13 26]);

puntos = puntos + 1.0*testAStar('zigzag10', 'ucs',        zigzagBoard(10), [14 259]);
puntos = puntos + 1.0*testAStar('zigzag10', 'euclidean',  zigzagBoard(10), [14 169]);
puntos = puntos + 1.0*testAStar('zigzag10', 'manhattan',  zigzagBoard(10), [14 187]);
puntos = puntos + 1.0*testAStar('zigzag10', 'chessboard', zigzagBoard(10), [14 150]);

puntos = puntos + 1.0*testAStar('loop10', 'ucs',        loopBoard(10), [7 36]);
puntos = puntos + 1.0*testAStar('loop10', 'euclidean',  loopBoard(10), [7 17]);
puntos = puntos + 1.0*testAStar('loop10', 'manhattan',  loopBoard(10), [7 21]);
puntos = puntos + 1.0*testAStar('loop10', 'chessboard', loopBoard(10), [7 16]);

puntos = puntos + 1.0*testAStar('lane10', 'ucs',        laneBoard(10), [7 50]);
puntos = puntos + 1.0*testAStar('lane10', 'euclidean',  laneBoard(10), [7 41]);
puntos = puntos + 1.0*testAStar('lane10', 'manhattan',  laneBoard(10), [7 42]);
puntos = puntos + 1.0*testAStar('lane10', 'chessboard', laneBoard(10), [7 41]);

puntos = puntos + 1.0*testAStar('threeLane10', 'ucs',        threeLaneBoard(10), [7 101]);
puntos = puntos + 1.0*testAStar('threeLane10', 'euclidean',  threeLaneBoard(10), [7 86]);
puntos = puntos + 1.0*testAStar('threeLane10', 'manhattan',  threeLaneBoard(10), [7 87]);
puntos = puntos + 1.0*testAStar('threeLane10', 'chessboard', threeLaneBoard(10), [7 86]);

set(0,'DefaultFigureVisible','on'); 


% 33% Funciones de coste

disp('[PLANIFICACIN CON PROGRAMACIN DINMICA]');

puntos = puntos + 9.0*testCost();

disp('[PLANIFICACIN ESTOCSTICA]');

puntos = puntos + 24.0*testStochasticCost();


total = 100;

% Respuestas a los ejercicios

try 
  resultados;
catch
  disp(['AVISO: Existe un problema en su fichero de respuestas a los ejercicios. Por favor, revise posibles errores...']);  
end

disp ([ 'Puntuacin total = ', num2str(100*(puntos/total)), '%'] );

%%%%%%

function vector = boards ()

vector(1) = clearBoard(20);
vector(2) = frontierBoard(20);
vector(3) = costBoard(20);
vector(4) = zigzagBoard(20);
vector(5) = pacmanBoard(20);
vector(6) = loopBoard(20);
vector(7) = laneBoard(20);
vector(8) = threeLaneBoard(20);

%%%%%%

function [pct ok total] = testInitialState ()

total = 0;
ok = 0;

problemas = boards();

for i=1:length(problemas)

board = problemas(i);

try 
  total = total + 1;
  state = initialState(board);
  ok = ok + 1;
catch
  disp(['[initialState] Error: No fue posible ejecutar la funcin initialState()']);  
end

try 
  total = total + 1;
  if (state.x == board.start.x)
     ok = ok + 1;
  else
     disp(['[initialState] Error: La coordenada X del estado inicial debera ser ', num2str(board.start.x)]);
  end
catch
  disp(['[initialState] Error: No fue posible acceder a la coordenada X del estado inicial.']);  
end

try 
  total = total + 1;
  if (state.y == board.start.y)
     ok = ok + 1;
  else
     disp(['[initialState] Error: La coordenada Y del estado inicial debera ser ', num2str(board.start.y)]);
  end
catch
  disp(['[initialState] Error: No fue posible acceder a la coordenada Y del estado inicial.']);  
end


try 
  total = total + 1;
  if (state.orientation == board.start.orientation)
     ok = ok + 1;
  else
     disp(['[initialState] Error: La orientacin del estado inicial debera ser ', board.start.orientation]);
  end
catch
  disp(['[initialState] Error: No fue posible acceder a la coordenada Y del estado inicial.']);  
end

try 
  total = total + 1;
  if (state.cost == 0)
     ok = ok + 1;
  else
     disp('[initialState] Error: El coste del estado inicial debera ser cero.');
  end
catch
  disp(['[initialState] Error: No fue posible acceder al coste del estado inicial.']);  
end

try 
  total = total + 1;
  if (state.prev == 0)
     ok = ok + 1;
  else
     disp('[initialState] Error: El estado inicial no proviene de ningn otro estado.');
  end
catch
  disp(['[initialState] Error: No fue posible acceder al miembro que indica que el estado inicial es realmente el inicial.']);  
end

end

disp(['Tests completados: ', num2str(ok), '/', num2str(total), ' @ initialState']);
pct = ok / total;


%%%%%%

function [pct ok total] = testSameState ()

total = 0;
ok = 0;

problemas = boards();
board = problemas(1);

try 
  total = total + 2;
  state = initialState(board);
  
  if sameState(state,state)
     ok = ok + 1;
  else
     disp('[sameState] Error: Un estado es siempre igual a s mismo.');
  end

  ok = ok + 1;
catch
  disp(['[sameState] Error: No fue posible ejecutar la funcin sameState()']);  
end

try 
  total = total + 1;
  state1 = initialState(board);
  state2 = initialState(board);
  state2.x = state2.x + 1;

  if ~sameState(state1,state2)
     ok = ok + 1;
  else
     disp('[sameState] Error: Dos estados son diferentes si difieren sus coordenadas X.');
  end
catch
  disp(['[sameState] Error: No fue posible ejecutar la funcin sameState()']);  
end

try 
  total = total + 1;
  state1 = initialState(board);
  state2 = initialState(board);
  state2.y = state2.y + 1;

  if ~sameState(state1,state2)
     ok = ok + 1;
  else
     disp('[sameState] Error: Dos estados son diferentes si difieren sus coordenadas Y.');
  end
catch
  disp(['[sameState] Error: No fue posible ejecutar la funcin sameState()']);  
end


try 
  total = total + 1;
  state1 = initialState(board);
  state2 = initialState(board);
  state1.orientation = 'S';
  state2.orientation = 'N';

  if ~sameState(state1,state2)
     ok = ok + 1;
  else
     disp('[sameState] Error: Dos estados son diferentes si difieren sus orientaciones (N,S,E,W).');
  end
catch
  disp(['[sameState] Error: No fue posible ejecutar la funcin sameState()']);  
end

try 
  total = total + 1;
  state1 = initialState(board);
  state2 = initialState(board);
  state2.prev = state2.prev + 1;
  state2.cost = state2.cost + 1;

  if sameState(state1,state2)
     ok = ok + 1;
  else
     disp('[sameState] Error: Dos estados son iguales si coinciden sus coordenadas y orientaciones.');
  end
catch
  disp(['[sameState] Error: No fue posible ejecutar la funcin sameState()']);  
end


disp(['Tests completados: ', num2str(ok), '/', num2str(total), ' @ sameState']);

pct = ok / total;


%%%%%%

function [pct ok total] = testFinalState ()

total = 0;
ok = 0;

problemas = boards();
problemas = boards();

for i=1:length(problemas)

board = problemas(i);

try 
  total = total + 1;
  state = initialState(board);
  
  if ~finalState(board,state)
     ok = ok + 1;
  else
     disp('[finalState] Error: El estado inicial no es un estado final del problema.');
  end

catch
  disp(['[finalState] Error: No fue posible ejecutar la funcin finalState()']);  
end

try 
  total = total + 1;
  state = initialState(board);
  state.x = board.goal.x;
  state.y = board.goal.y;

  if finalState(board,state)
     ok = ok + 1;
  else
     disp('[finalState] Error: El estado final del problema no fue identificado como tal.');
  end

catch
  disp(['[finalState] Error: No fue posible ejecutar la funcin finalState()']);  
end

try 
  total = total + 1;
  state = initialState(board);
  state.x = board.goal.x;
  state.y = board.goal.y;
  state.orientation = 'N';

  if finalState(board,state)
     ok = ok + 1;
  else
     disp('[finalState] Error: El estado final del problema no fue identificado como tal.');
  end

catch
  disp(['[finalState] Error: No fue posible ejecutar la funcin finalState()']);  
end

try 
  total = total + 1;
  state = initialState(board);
  state.x = board.goal.x;
  state.y = board.goal.y;
  state.orientation = 'S';

  if finalState(board,state)
     ok = ok + 1;
  else
     disp('[finalState] Error: El estado final del problema no fue identificado como tal.');
  end

catch
  disp(['[finalState] Error: No fue posible ejecutar la funcin finalState()']);  
end

try 
  total = total + 1;
  state = initialState(board);
  state.x = board.goal.x;
  state.y = board.goal.y;
  state.orientation = 'E';

  if finalState(board,state)
     ok = ok + 1;
  else
     disp('[finalState] Error: El estado final del problema no fue identificado como tal.');
  end

catch
  disp(['[finalState] Error: No fue posible ejecutar la funcin finalState()']);  
end

try 
  total = total + 1;
  state = initialState(board);
  state.x = board.goal.x;
  state.y = board.goal.y;
  state.orientation = 'W';

  if finalState(board,state)
     ok = ok + 1;
  else
     disp('[finalState] Error: El estado final del problema no fue identificado como tal.');
  end

catch
  disp(['[finalState] Error: No fue posible ejecutar la funcin finalState()']);  
end

end

disp(['Tests completados: ', num2str(ok), '/', num2str(total), ' @ finalState']);

pct = ok / total;

%%%%%%

function [pct ok total] = testNextState ()

total = 0;
ok = 0;

board = clearBoard(5);

try 

  total = total + 12 + 12;
  state = initialState(board);


  % (2,2,*) 
  
  state.x = 2;
  state.y = 2;

  % R

  state.orientation = 'N';

  new = nextState(board,state,'R');
  
  if (new.x==3 & new.y==3 & new.orientation=='E')
     ok = ok + 1;
  else
     disp(['[nextState] Error al girar a la derecha desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  state.orientation = 'E';

  new = nextState(board,state,'R');
  
  if (new.x==3 & new.y==1 & new.orientation=='S')
     ok = ok + 1;
  else
     disp(['[nextState] Error al girar a la derecha desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  state.orientation = 'S';

  new = nextState(board,state,'R');
  
  if (new.x==1 & new.y==1 & new.orientation=='W')
     ok = ok + 1;
  else
     disp(['[nextState] Error al girar a la derecha desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  state.orientation = 'W';

  new = nextState(board,state,'R');
  
  if (new.x==1 & new.y==3 & new.orientation=='N')
     ok = ok + 1;
  else
     disp(['[nextState] Error al girar a la derecha desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
     disp(['[nextState] (',num2str(next.x),',',num2str(next.y),',', state.orientation,')?']);
  end

  % L

  state.orientation = 'N';

  new = nextState(board,state,'L');
  
  if (new.x==1 & new.y==3 & new.orientation=='W')
     ok = ok + 1;
  else
     disp(['[nextState] Error al girar a la izquierda desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  state.orientation = 'E';

  new = nextState(board,state,'L');
  
  if (new.x==3 & new.y==3 & new.orientation=='N')
     ok = ok + 1;
  else
     disp(['[nextState] Error al girar a la izquierda desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  state.orientation = 'S';

  new = nextState(board,state,'L');
  
  if (new.x==3 & new.y==1 & new.orientation=='E')
     ok = ok + 1;
  else
     disp(['[nextState] Error al girar a la izquierda desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  state.orientation = 'W';

  new = nextState(board,state,'L');
  
  if (new.x==1 & new.y==1 & new.orientation=='S')
     ok = ok + 1;
  else
     disp(['[nextState] Error al girar a la izquierda desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  % G

  state.orientation = 'N';

  new = nextState(board,state,'G');
  
  if (new.x==2 & new.y==3 & new.orientation=='N')
     ok = ok + 1;
  else
     disp(['[nextState] Error al seguir en lnea recta desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  state.orientation = 'E';

  new = nextState(board,state,'G');
  
  if (new.x==3 & new.y==2 & new.orientation=='E')
     ok = ok + 1;
  else
     disp(['[nextState] Error al seguir en lnea recta desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  state.orientation = 'S';

  new = nextState(board,state,'G');
  
  if (new.x==2 & new.y==1 & new.orientation=='S')
     ok = ok + 1;
  else
     disp(['[nextState] Error al seguir en lnea recta desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  state.orientation = 'W';

  new = nextState(board,state,'G');
  
  if (new.x==1 & new.y==2 & new.orientation=='W')
     ok = ok + 1;
  else
     disp(['[nextState] Error al seguir en lnea recta desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  % (n,n,*)

  state.x = board.n;
  state.y = board.n;

  % R

  state.orientation = 'N';

  new = nextState(board,state,'R');
  
  if (new.x==board.n & new.y==board.n & new.orientation=='E')
     ok = ok + 1;
  else
     disp(['[nextState] Error al girar a la derecha desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  state.orientation = 'E';

  new = nextState(board,state,'R');
  
  if (new.x==board.n & new.y==board.n-1 & new.orientation=='S')
     ok = ok + 1;
  else
     disp(['[nextState] Error al girar a la derecha desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  state.orientation = 'S';

  new = nextState(board,state,'R');
  
  if (new.x==board.n-1 & new.y==board.n-1 & new.orientation=='W')
     ok = ok + 1;
  else
     disp(['[nextState] Error al girar a la derecha desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  state.orientation = 'W';

  new = nextState(board,state,'R');
  
  if (new.x==board.n-1 & new.y==board.n & new.orientation=='N')
     ok = ok + 1;
  else
     disp(['[nextState] Error al girar a la derecha desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  % L

  state.orientation = 'N';

  new = nextState(board,state,'L');
  
  if (new.x==board.n-1 & new.y==board.n & new.orientation=='W')
     ok = ok + 1;
  else
     disp(['[nextState] Error al girar a la izquierda desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  state.orientation = 'E';

  new = nextState(board,state,'L');
  
  if (new.x==board.n & new.y==board.n & new.orientation=='N')
     ok = ok + 1;
  else
     disp(['[nextState] Error al girar a la izquierda desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  state.orientation = 'S';

  new = nextState(board,state,'L');
  
  if (new.x==board.n & new.y==board.n-1 & new.orientation=='E')
     ok = ok + 1;
  else
     disp(['[nextState] Error al girar a la izquierda desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  state.orientation = 'W';

  new = nextState(board,state,'L');
  
  if (new.x==board.n-1 & new.y==board.n-1 & new.orientation=='S')
     ok = ok + 1;
  else
     disp(['[nextState] Error al girar a la izquierda desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  % G

  state.orientation = 'N';

  new = nextState(board,state,'G');
  
  if (new.x==board.n & new.y==board.n & new.orientation=='N')
     ok = ok + 1;
  else
     disp(['[nextState] Error al seguir en lnea recta desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  state.orientation = 'E';

  new = nextState(board,state,'G');
  
  if (new.x==board.n & new.y==board.n & new.orientation=='E')
     ok = ok + 1;
  else
     disp(['[nextState] Error al seguir en lnea recta desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  state.orientation = 'S';

  new = nextState(board,state,'G');
  
  if (new.x==board.n & new.y==board.n-1 & new.orientation=='S')
     ok = ok + 1;
  else
     disp(['[nextState] Error al seguir en lnea recta desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end

  state.orientation = 'W';

  new = nextState(board,state,'G');
  
  if (new.x==board.n-1 & new.y==board.n & new.orientation=='W')
     ok = ok + 1;
  else
     disp(['[nextState] Error al seguir en lnea recta desde (',num2str(state.x),',',num2str(state.y),',', state.orientation,') en un tablero de ',num2str(board.n),'x',num2str(board.n),'.']);
  end


catch
  disp(['[nextState] Error: No fue posible ejecutar la funcin nextState()']);  
end

disp(['Tests completados: ', num2str(ok), '/', num2str(total), ' @ nextState']);

pct = ok / total;



%%%%%%

function [pct ok total] = testHeuristic (testsuite, method, board, key)

total = 0;
ok = 0;

try 
  total = total + 1;
  state = initialState(board);
  h = heuristic(method,board,state);
  
  if (abs(h-key)<0.0001)
     ok = ok + 1;
  else
     disp(['[heuristic @ ',testsuite,'] Error: Valor heurstico ', num2str(h),' incorrecto para la heurstica ''',method,''' (debera ser ',num2str(key),'.']);  
  end

catch
  disp(['[heuristic] Error: No fue posible ejecutar la funcin heuristic()']);  
end


disp(['Tests completados: ', num2str(ok), '/', num2str(total), ' @ heuristic ''', method, '''']);

pct = ok / total;

%%%%%%

function [pct ok total] = testAStar (testsuite, method, board, key)

total = 0;
ok = 0;

try 

  disp(['[', testsuite, '] A* ',method]);

  total = total + 4;
  [solucion, nodos, coste] = astar(board,method);

  ok = ok + 1;
  
  if (key(1)==0 & length(solucion)==0) | (length(solucion)-1 == key(1))
     ok = ok + 1;
  elseif (length(solucion)-1 > key(1))
     disp('- Solucin subptima.');
  else
     disp('- Solucin incorrecta.');
  end

  if (nodos == key(2))
     ok = ok + 1;
  else
     disp('- Nmero incorrecto de nodos expandidos.');
  end

  h = heuristic(method,board, initialState(board));

  if (key(1)==0) || (h<=coste)
     ok = ok + 1;
  else
     disp('- Heurstica inadmisible.');
  end;

catch
  disp(['[A*] Error: No fue posible ejecutar la funcin astar()']);  
end


disp(['Tests completados: ', num2str(ok), '/', num2str(total), ' @ A* ''', method, '''']);

pct = ok / total;


%%%%%


function ok = checkCost (board, state, action, expected)

  next = nextState(board,state,action);
  actual = cost(board,state,action,next);

  if (abs(actual-expected)<0.0001)
     ok = 1;
  else
     ok = 0;
     disp(['[ERROR @ (',num2str(state.x),',',num2str(state.y),',',state.orientation,') -> ',action,'] Error: Coste ', num2str(actual),' incorrecto (se esperaba ',num2str(expected),').']);  
  end

%%%%%

function [pct ok total] = testCost ()

total = 0;
ok = 0;

try 

  board = loopBoard(10);
  state = initialState(board);
 
  total = total + 1;
  ok    = ok + checkCost(board, state, 'G', 1);

  total = total + 1;
  ok    = ok + checkCost(board, state, 'R', 2*board.wall + 2);

  total = total + 1;
  ok    = ok + checkCost(board, state, 'L', 1 + 2);

  state.x = board.n;
  state.y = board.n;
  state.orientation = 'S';

  total = total + 1;
  ok    = ok + checkCost(board, state, 'G', 1);

  total = total + 1;
  ok    = ok + checkCost(board, state, 'R', 1 + 2);

  total = total + 1;
  ok    = ok + checkCost(board, state, 'L', board.wall + 1 + 2);

catch
  disp(['[cost] Error: No fue posible ejecutar la funcin cost()']);  
end

disp(['Tests completados: ', num2str(ok), '/', num2str(total), ' @ cost']);

pct = ok / total;


%%%%%

function ok = checkStochasticCost (board, state, action, failureProbability, expected)

  actual = stochasticCost(board,state,action,failureProbability);

  if (abs(actual-expected)<0.0001)
     ok = 1;
  else
     ok = 0;
     disp(['[ERROR @ (',num2str(state.x),',',num2str(state.y),',',state.orientation,') -> ',action,'] Error: Coste ', num2str(actual),' incorrecto (se esperaba ',num2str(expected),' cuando la probabilidad de fallo es ',num2str(failureProbability),').']);  
  end

%%%%%

function [pct ok total] = testStochasticCost ()

total = 0;
ok = 0;

try 

  board = loopBoard(10);

  % P = 0.01

  state = initialState(board);
  failureProbability = 0.01;
 
  total = total + 1;
  ok    = ok + checkStochasticCost(board, state, 'G', failureProbability, 101.015);

  total = total + 1;
  ok    = ok + checkStochasticCost(board, state, 'R', failureProbability, 19801.99);

  total = total + 1;
  ok    = ok + checkStochasticCost(board, state, 'L', failureProbability, 2.98);

  state.x = board.n;
  state.y = board.n;
  state.orientation = 'S';

  total = total + 1;
  ok    = ok + checkStochasticCost(board, state, 'G', failureProbability, 51.02);

  total = total + 1;
  ok    = ok + checkStochasticCost(board, state, 'R', failureProbability, 2.98);

  total = total + 1;
  ok    = ok + checkStochasticCost(board, state, 'L', failureProbability, 9902.98);

  % P = 0.1

  state = initialState(board);
  failureProbability = 0.1;
 
  total = total + 1;
  ok    = ok + checkStochasticCost(board, state, 'G', failureProbability, 1001.15);

  total = total + 1;
  ok    = ok + checkStochasticCost(board, state, 'R', failureProbability, 18001.9);

  total = total + 1;
  ok    = ok + checkStochasticCost(board, state, 'L', failureProbability, 2.8);

  state.x = board.n;
  state.y = board.n;
  state.orientation = 'S';

  total = total + 1;
  ok    = ok + checkStochasticCost(board, state, 'G', failureProbability, 501.2);

  total = total + 1;
  ok    = ok + checkStochasticCost(board, state, 'R', failureProbability, 2.8);

  total = total + 1;
  ok    = ok + checkStochasticCost(board, state, 'L', failureProbability, 9002.8);


catch
  disp(['[cost] Error: No fue posible ejecutar la funcin stochasticCost()']);  
end

disp(['Tests completados: ', num2str(ok), '/', num2str(total), ' @ stochasticCost']);

pct = ok / total;
